#!/usr/bin/perl

use DBI;
use String::Escape qw( printable unprintable );

$dbdriver = "mysql";		# mySQL-Datenbank als Grundlage
$dbhost = "";			# Host
$dbuser = "www-dummy";		# Benutzer
$dbpass = "sqltest";		# Passwort
$dbase  = "wmlgen";		# Datenbank

$thispl = "index.pl";
$workpl = "service.pl";

&getform;
$dbh = DBI->connect("DBI:$dbdriver:$dbhost",$dbuser,$dbpass);

# Benutzererkennung

$user{'sessionid'} = $form{'sessionid'};
# SessionID generieren, falls noch nicht vorhanden
while (length($user{'sessionid'}) < 32) {
  $user{'sessionid'} = join '', ("1".."9","a".."z","A".."Z",0..9)[map {rand 36} 0..31]; 
  # Kollisionen mit vorhandenen SessionIDs ausschliessen
  if ($dbh->selectrow_array("select count(*) from $dbase.benutzer where sessionid = '".$user{'sessionid'}."'") > 0) {
    $user{'sessionid'} = "";
  }
}
# Anmeldekredenzen gegeben?
if ($form{'login_name'} ne "") {
  # auf gltigen Name und Passwort prfen
  $nr = $dbh->selectrow_array("select nr from $dbase.benutzer where name = '$form{'login_name'}' and password = '$form{'login_password'}'");
  if ($nr > 0) {
    # Anmeldung erfolgreich, SessionID mit Benutzer verknpfen
    $dbh->do("update $dbase.benutzer set sessionid = '$user{'sessionid'}' where nr = $nr");
  } else {
    # Anmeldekredenzen ungltig
    $h{'body'} .= "<p>Ungltiger Login oder Password.</p>\n";
  }
}

# Benutzerdaten laden
(
 $user{'nr'},
 $user{'name'},
 $user{'password'}
) = ($dbh->selectrow_array(
			   "select nr, name, password from $dbase.benutzer where sessionid = '".$user{'sessionid'}."'"
			  ));


# Navigation
$h{'body'} .= "<h1>Testdatenbank</h1>\n";
$h{'body'} .= "<p>".($user{'nr'} != 0 ? "[\U$user{'name'}\E]" : "[<i>unbekannt</i>]")."\n".
  "<a href=\"$thispl?sessionid=$user{'sessionid'}\&einstellungen=1\">Einstellungen</a>\n".
  "| <a href=\"$thispl?sessionid=$user{'sessionid'}\&anzeigen=1\">Datenbank anzeigen</a>\n".
  "| <a href=\"$thispl?sessionid=$user{'sessionid'}\&logout=1\">Ausloggen</a>\n".
  "| <a href=\"$thispl?sessionid=$user{'sessionid'}\&userlist=1\">Benutzerliste</a>\n".
  "</p>\n";


# nicht angemeldet, Formular anzeigen
if ($user{'nr'} == 0) {
  $h{'body'} .= "<form method=post action=$thispl>\n";
  $h{'body'} .= "Bitte anmelden - Name: <input type=text name=login_name size=10 maxlength=10>\n";
  $h{'body'} .= "Password: <input type=password name=login_password size=10 maxlength=16>\n";
  $h{'body'} .= "<input type=submit value=\"anmelden\">\n";
  $h{'body'} .= "<input type=hidden name=sessionid value=\"$user{'sessionid'}\">\n";
  $h{'body'} .= "</form>\n";
}

# Ausloggen

elsif ($form{'logout'}) {
  $dbh->do("update $dbase.benutzer set sessionid = null where nr = $user{'nr'}");
  $h{'body'} .= "<p>Du wurdest abgemeldet.</p>\n";
}

# Benutzer hinzufgen

elsif (defined(my $mode = $form{'adduser'})) {

  if ($mode eq "save") {

    my $name = $form{'name'};
    $name =~ s/[^a-zA-Z0-9_]//gs;
    my $password = $form{'password'};
    $password =~ s/[^a-zA-Z0-9_]//gs;
		
    if (($name eq "") or ($name ne $form{'name'})) {
      $h{'body'} .= "<p>Leerer Name oder Name beeinhaltet ungltige Zeichen.</p>\n";
    } elsif (($password eq "") or ($password ne $form{'password'})) {
      $h{'body'} .= "<p>Leeres Password oder Password beeinhaltet ungltige Zeichen.</p>\n";
    } elsif ($dbh->selectrow_array("select nr from $dbase.benutzer where name like '$name'") > 0) {
      $h{'body'} .= "<p>Ein Benutzer mit diesem Name existiert bereits</p>\n";
    } else {
      $dbh->do("insert into $dbase.benutzer (name, password) values('$name', '$password')");
      $h{'body'} .= "<p>Benutzer <b>$name</b> wurde eingetragen. Password: <b>$password</b>.</p>\n";
    }
		
  } else {

    my $password = join '', (0..9)[map {rand 10} 0..3]; 

		
    $h{'body'} .= "<p><b>Neuen Benutzer eintragen</b></p>\n".
      "<p>Sowohl beim Name als auch beim Password nur Zeichen a-z, A-Z, 0-9 sowie den Unterstrich benutzen!</p>\n".
	"<p>Gro- und Kleinschreibung ist sowohl beim Name als auch beim Password wichtig!</p>\n";
		
    $h{'body'} .= "<form method=post action=$thispl>\n";
    $h{'body'} .= "Name: <input type=text name=name size=10 maxlength=10>\n";
    $h{'body'} .= "Password: <input type=text name=password size=16 maxlength=16 value=\"$password\">\n";
    $h{'body'} .= "<input type=submit value=\"anlegen\">\n";
    $h{'body'} .= "<input type=hidden name=sessionid value=\"$user{'sessionid'}\">\n";
    $h{'body'} .= "<input type=hidden name=adduser value=save>\n";
    $h{'body'} .= "</form>\n";
  }

}

# Benutzerliste

elsif (defined(my $mode = $form{'userlist'})) {

  $h{'body'} .= "<h2>Benutzer</h2>\n";

  $h{'body'} .= "<ul>\n";
  my $cmd = $dbh->prepare("select benutzer.nr, benutzer.name from $dbase.benutzer order by name");
  $cmd->execute();
  while (my ($nr, $name) = $cmd->fetchrow_array) {
    $h{'body'} .= "<li>$name</li>\n";
  }
  $cmd->finish;
  $h{'body'} .= "</ul>\n";

  $h{'body'} .= "<p><a href=\"$thispl?sessionid=$user{'sessionid'}\&adduser=1\">Neuen Benutzer anlegen</a></p>\n";
}


# Liste der DB ausgeben

elsif (defined($form{'anzeigen'})) {
	
  $h{'body'} .= "<a href=\"$thispl?delall=1&ts=0&sessionid=$user{'sessionid'}\">alle lschen</a><br>" .
    "<table border=0 width=\"100%\" cellspacing=2 cellpadding=3>\n".
      "<tr>\n".
	"<th>Bearbeiten</th>".
	  "<th>Timestamp</th>\n".
	    "<th>Seed</th>\n".
	      "<th>Configuration</th>\n".
		"<th>Wml</th>\n".
		  "<th>Kommentar</th>\n".
		    "</tr>\n";
  $cmd = $dbh -> prepare("select timestamp, cfg, seed, wml, kommentar from $dbase.dokumente".($form{'suchtitel'} ne "" ? " where timestamp like '%$form{'suchtitel'}%'" : "")." order by dokumente.timestamp");
  $res = $cmd -> execute;
  while (my ($ts, $cfg, $seed, $wml, $kommentar) = $cmd->fetchrow_array) {
    $h{'body'} .= "<tr>\n".
      "<td><a href=\"$thispl?del=1&ts=$ts&sessionid=$user{'sessionid'}\">lschen</a><br>".
	"<a href=\"$thispl?edit=1&ts=$ts&sessionid=$user{'sessionid'}\">bearbeiten</a> </td>".
	  "<td>$ts</td>\n".
	    "<td>$seed</td>\n".
	      "<td><form><textarea name=\"cfg\" cols=\"60%\" rows=\"5\" wrap=\"off\" readonly>$cfg</textarea></form></td>\n".
		"<td><form><textarea name=\"wml\" cols=\"60%\" rows=\"5\" wrap=\"off\" readonly>$wml</textarea></form></td>\n".
		  "<td><form><textarea name=\"kommentar\" cols=\"50%\" rows=\"5\" wrap=\"off\" readonly>$kommentar</textarea></form></td>" .
		    "</tr>\n";
  }
  $cmd->finish;
  $h{'body'} .= "</table>\n" .
    "<a href=\"$thispl?delall=1&ts=0&sessionid=$user{'sessionid'}\">alle lschen</a><br>";



}


#lschen
elsif (defined(my $titel = $form{'del'})) {
  $querystring = "DELETE FROM $dbase.dokumente WHERE timestamp = \'$form{'ts'}\'";
  $dbh->do ($querystring)
    or die $dbh->errstr();

  if ($dbh->selectrow_array ("select count(*)  from $dbase.dokumente where timestamp = \'$form{'ts'}\'") > 0) {
    die "Konnte den Datensatz nicht lschen\n";
  }
  $h{'body'} .= "Datensatz erfolgreich gelscht";
}

#bearbeiten
elsif (defined(my $titel = $form{'edit'})) {
  
  $cmd = $dbh -> prepare("select dokumente.timestamp, dokumente.cfg, dokumente.seed, dokumente.wml, dokumente.kommentar from $dbase.dokumente ". "where timestamp = \'$form{'ts'}\'");
  $res = $cmd -> execute;
  my ($ts, $cfg, $seed, $wml, $kommentar) = $cmd->fetchrow_array();

  $h{'body'} .= "<form method=post action=$thispl>\n";
  $h{'body'} .= "Datensatz bearbeiten<br><br>" .
    "<input type=\"submit\" value=\"nderungen bernehmen\"><br><br>" .
  "<textarea name=\"kommentar_neu\" cols=\"100%\" rows=\"10\" wrap=\"off\">$kommentar</textarea><br><br>";
  $h{'body'} .= "seed: <input type=\"text\" name=\"seed_neu\" size=\"20\" maxlength=\"20\" value=\"$seed\"><br><br>";
  $h{'body'} .= "<textarea name=\"cfg_neu\" cols=\"100%\" rows=\"30\" wrap=\"off\">$cfg</textarea><br><br>";
  $h{'body'} .= "<textarea name=\"wml_neu\" cols=\"100%\" rows=\"30\" wrap=\"off\" readonly>$wml</textarea><br><br>";
  $h{'body'} .= "<input type=\"submit\" value=\"nderungen bernehmen\">\n";
  $h{'body'} .= "<input type=\"hidden\" name=\"sessionid\" value=\"$user{'sessionid'}\">\n";
  $h{'body'} .= "<input type=\"hidden\" name=\"commitchanges\" value=1>\n";
  $h{'body'} .= "<input type=\"hidden\" name=\"ts\" value=\"$form{'ts'}\">\n";
  $h{'body'} .= "</form>\n";
}

#nderungen bernehmen
elsif (defined(my $titel = $form{'commitchanges'})) {
  $wml_neu = $form{'wml_neu'};
  $cfg_neu = $form{'cfg_neu'};
  $cfg_neu =~ s/\"/\\\"/go;
  $kommentar_neu = $form{'kommentar_neu'};
  $kommentar_neu =~ s/\"/\\\"/go;


  $qs = "update $dbase.dokumente set seed = $form{'seed_neu'}, " .
    "cfg = '$cfg_neu', " .
    "kommentar = '$kommentar_neu' ".
    "where timestamp = \'$form{'ts'}\'";
  $dbh->do("$qs");

  $h{'body'} .= "folgende nderungen wurden in der Datenbank gespeichert<br><br>";

  $h{'body'} .= "<form method=post action=$thispl>\n" .
    "seed: <input type=\"text\" name=\"seed_neu\" size=\"20\" maxlength=\"20\" value=\"$form{'seed_neu'}\"><br><br>";
  $h{'body'} .= "<textarea name=\"cfg_neu\" cols=\"100%\" rows=\"30\" wrap=\"off\" readonly>" .
    "$form{'cfg_neu'}</textarea><br><br>";
  $h{'body'} .= "<textarea name=\"wml_neu\" cols=\"100%\" rows=\"30\" wrap=\"off\" readonly>" .
    "$form{'wml_neu'}</textarea><br><br>";
  $h{'body'} .= "<textarea name=\"kommentar_neu\" cols=\"100%\" rows=\"10\" wrap=\"off\" readonly>" .
    "$form{'kommentar_neu'}</textarea><br><br>";
  $h{'body'} .= "</form>\n";
}

#alles lschen
elsif (defined(my $titel = $form{'delall'})) {
  $querystring = "DELETE FROM $dbase.dokumente";
  $dbh->do ($querystring)
    or die $dbh->errstr();

  if ($dbh->selectrow_array ("select count(*)  from $dbase.dokumente") > 0) {
    die "konnte nicht alle Datenstze lschen\n";
  }
  $h{'body'} .= "alle Datenstze erfolgreich gelscht";
}


# Ende

#$h{'body'} .= "<hr><xmp>DEBUG\nSessionID: $user{'sessionid'}</xmp>\n"; # DEBUG
$dbh->disconnect;
&parsehtml("standard.htm");

###############################################################################
###############################################################################
###############################################################################

sub parsehtml {

  print "content-type:text/html\n\n";

  my $template = $_[0];
  my $html = "";
  if (open (F,$template)) {
    while (<F>) {
      $html .= $_;
    }
    close (F);
  } else {
    print "<html><body>\n".
      "<h1>Schwerwiegender Fehler</h1>\n".
	"<p>kann das Template <u>$template</u> nicht laden:<br>$!</p>\n".
	  "</body></html>\n";
  }

  while ($html =~ m/<!--\s*var\:(.*?)\=\"(.*?)\"-->/gis) {
    $h{$1} = $2;
  }
  $html =~ s/<!--\s*var:\s*(.*?)\s*-->[\n]{0,}//gis;

  while ($html =~ m/<!--\s*cgi:\s*(\S+?)\s*-->/) {
    $html =~ s/<!--\s*cgi:\s*(\S+?)\s*-->/$h{$1}/gis;
  }

  print $html;
}

sub getform {

  %form = ();
  my ($value, $name, @Formularfelder);

  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    $Daten = $ENV{'QUERY_STRING'}
  } else {
    read(STDIN, $Daten, $ENV{'CONTENT_LENGTH'});
  }

  @Formularfelder = split(/&/, $Daten);
  my $pc = 0;
  foreach $Feld (@Formularfelder) {
    $pc++;
    ($name, $value) = split(/=/, $Feld);   
    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $name =~ s/<!--(.\n)*-->//g;      
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.\n)*-->//g;      
    $form{$name}=$value;
  }
}

sub dropdown {

  my ($value,$shown);
  my $name = $_[0];
  my @choice = split (/\t/,$_[1]);
  my $pre = $_[2];

  my $temp = "<select name=\"$name\" size=1 ".$_[3].">\n";
  foreach $option (@choice) {
    ($value,$shown) = split (/;/,$option);
    $shown = $value if ($shown eq "");
    $temp .= "<option value=\"$value\"";
    $temp .= " selected" if ($pre eq $value);
    $temp .= ">$shown";
  }
  $temp .= "</select>\n";
  return $temp;
	
}

sub myescape {
  $st = $_[0];
  return $st;
}
